
#include <SoftSerial.h>
SoftSerial btSerial(10, 11); // RX | TX



#include <Adafruit_NeoPixel.h>
#ifdef __AVR__
#include <avr/power.h> // Required for 16 MHz Adafruit Trinket
#endif

#define LED_PIN   7
#define LED_COUNT 8
Adafruit_NeoPixel strip(LED_COUNT, LED_PIN, NEO_RGB + NEO_KHZ400);



int  rnd0, rnd1, rnd2, rnd3;
int brit = 100,  b = 250;
String rxMessage, lastMessage;
float speedRaito = 1, s_fade = 20 , s_wipe = 90, s_chase = 400;



//////////////////////////// FUNCTIONS ///////////////////////////////////
void theaterChase(uint32_t color, float wait) {
  for (int a = 0; a < 3; a++) { // Repeat 10 times...
    for (int b = 0; b < 3; b++) { //  'b' counts from 0 to 2...
      strip.clear();         //   Set all pixels in RAM to 0 (off)
      // 'c' counts up from 'b' to end of strip in steps of 3...
      for (int c = b; c < strip.numPixels(); c += 3) {
        strip.setPixelColor(c, color); // Set pixel 'c' to value 'color'
        if (btSerial.available()) {
          return;
        }
      }
      strip.show(); // Update strip with new contents
      delay(wait);  // Pause for a moment
    }
  }
}

void colorWipe(uint32_t color, int wait) {

  if (wait > 0) {
    for (int i = 0; i <= strip.numPixels() - 1; i++) {  // For each pixel in strip...
      strip.setPixelColor(i, color);                    //  Set pixel's color (in RAM)
      strip.show();                                     //  Update strip to match
      delay(wait);
      if (btSerial.available()) {
        return;
      }
    }
  }
  else if (wait < 0) {
    wait = wait * -1;
    for (int i = strip.numPixels(); i >= 0 ; i--) { // For each pixel in strip...
      strip.setPixelColor(i, color);               //  Set pixel's color (in RAM)
      strip.show();                                //  Update strip to match
      delay(wait);
      if (btSerial.available()) {
        return;
      }
    }
  }
}

void stripFill(uint32_t color, int s = 0 , int f = strip.numPixels() , char i = '0') {

  for (int i = s; i < f; i++) { // For each pixel in strip...
    strip.setPixelColor(i, color);         //  Set pixel's color (in RAM)
  }
  if (i == 'n') {
    return ;
  }
  strip.show();
}

void rainbow(float wait) {
  for (long firstPixelHue = 0; firstPixelHue < 5 * 65536; firstPixelHue += 256) {
    for (int i = 0; i < strip.numPixels(); i++) { // For each pixel in strip...
      int pixelHue = firstPixelHue + (i * 65536L / strip.numPixels());
      strip.setPixelColor(i, strip.gamma32(strip.ColorHSV(pixelHue)));

      if (btSerial.available()) {
        return;
      }

    }
    strip.show(); // Update strip with new contents
    delay(wait);  // Pause for a moment
  }
}

void ledFade(uint32_t color, float wait) {

  strip.clear();
  if (wait == 0) {
    for (int i = 0 ; i < 3 ; i++ ) {
      stripFill(strip.Color(  255, 0,   0));
      delay(500);
      strip.clear();

      if (btSerial.available()) {
        return;
      }

    }
  }

  if (wait > 0) {
    for (int i = 0 ; i < 150 ; i = i + 5) {
      strip.setBrightness(i);
      for (int i = 0; i < strip.numPixels(); i++) {
        strip.setPixelColor(i, color);
      }
      strip.show();
      delay(wait);
    }
    return;
  }
  if (wait < 0) {
    for (int i = 150 ; i > 0 ; i = i - 4) {
      strip.setBrightness(i);
      for (int i = 0; i < strip.numPixels(); i++) {
        strip.setPixelColor(i, color);
      }
      strip.show();
      delay(wait * (-1));
    }
    return;
  }
}

void nightRider(float wait) {

  for (int i = 0; i <= strip.numPixels(); ++i) {

    if (btSerial.available()) {
      return;
    }

    b = 250;
    strip.setPixelColor(i, strip.Color(b, 0, 0));
    strip.setPixelColor(i - 1, strip.Color(b , 0, 0));
    strip.setPixelColor(i - 2, strip.Color(b * 12 / 20, 0, 0));
    strip.setPixelColor(i - 3, strip.Color(b * 12 / 20, 0, 0));
    strip.setPixelColor(i - 4, strip.Color(b * 10 / 20, 0, 0));
    strip.setPixelColor(i - 5, strip.Color(b * 10 / 20, 0, 0));
    strip.setPixelColor(i - 6, strip.Color(b * 8 / 20, 0, 0));
    strip.setPixelColor(i - 7, strip.Color(b * 8 / 20, 0, 0));
    strip.setPixelColor(i - 8, strip.Color(b * 6 / 20, 0, 0));
    strip.setPixelColor(i - 9, strip.Color(b * 6 / 20, 0, 0));
    strip.setPixelColor(i - 10, strip.Color(b * 4 / 20, 0, 0));
    strip.setPixelColor(i - 11, strip.Color(b * 4 / 20, 0, 0));
    strip.setPixelColor(i - 12, strip.Color(b * 2 / 20, 0, 0));
    strip.setPixelColor(i - 13, strip.Color(b * 2 / 20, 0, 0));
    strip.setPixelColor(i - 14, strip.Color(b * 1 / 20, 0, 0));
    strip.setPixelColor(i - 15, strip.Color(b * 1 / 20, 0, 0));
    strip.setPixelColor(i - 16, strip.Color(0, 0, 0));
    if (i == 0) {
      strip.setPixelColor( 15, strip.Color(0, 0, 0));
    }
    if (i == 1) {
      strip.setPixelColor( 14, strip.Color(0, 0, 0));
    }
    if (i == 2) {
      strip.setPixelColor( 13, strip.Color(0, 0, 0));
    }
    if (i == 3) {
      strip.setPixelColor( 12, strip.Color(0, 0, 0));
    }
    if (i == 4) {
      strip.setPixelColor( 11, strip.Color(0, 0, 0));
    }
    if (i == 5) {
      strip.setPixelColor( 10, strip.Color(0, 0, 0));
    }
    if (i == 6) {
      strip.setPixelColor( 9, strip.Color(0, 0, 0));
    }
    if (i == 7) {
      strip.setPixelColor( 8, strip.Color(0, 0, 0));
    }
    if (i == 8) {
      strip.setPixelColor( 7, strip.Color(0, 0, 0));
    }
    strip.show();
    if (i != strip.numPixels()) delay(wait);

  }

  for (int j = strip.numPixels()  ; j >= 0 ; --j) {

    if (btSerial.available()) {
      return;
    }

    strip.setPixelColor(j , strip.Color(b, 0, 0));
    strip.setPixelColor(j + 1 , strip.Color(b, 0, 0));
    strip.setPixelColor(j + 2 , strip.Color(b * 12 / 20, 0, 0));
    strip.setPixelColor(j + 3 , strip.Color(b * 12 / 20, 0, 0));
    strip.setPixelColor(j + 4 , strip.Color(b * 10 / 20, 0, 0));
    strip.setPixelColor(j + 5 , strip.Color(b * 10 / 20, 0, 0));
    strip.setPixelColor(j + 6 , strip.Color(b * 8 / 20, 0, 0));
    strip.setPixelColor(j + 7 , strip.Color(b * 8 / 20, 0, 0));
    strip.setPixelColor(j + 8 , strip.Color(b * 6 / 20, 0, 0));
    strip.setPixelColor(j + 9 , strip.Color(b * 6 / 20, 0, 0));
    strip.setPixelColor(j + 10 , strip.Color(b * 4 / 20, 0, 0));
    strip.setPixelColor(j + 11 , strip.Color(b * 4 / 20, 0, 0));
    strip.setPixelColor(j + 12 , strip.Color(b * 2 / 20, 0, 0));
    strip.setPixelColor(j + 13 , strip.Color(b * 2 / 20, 0, 0));
    strip.setPixelColor(j + 14 , strip.Color(b * 1 / 20, 0, 0));
    strip.setPixelColor(j + 15 , strip.Color(b * 1 / 20, 0, 0));
    strip.setPixelColor(j + 16, strip.Color(0, 0, 0));
    if (j == strip.numPixels() - 1 ) {
      strip.setPixelColor(strip.numPixels() - 16, strip.Color(0, 0, 0));
    }
    if (j == strip.numPixels() - 2 ) {
      strip.setPixelColor(strip.numPixels() - 15, strip.Color(0, 0, 0));
    }
    if (j == strip.numPixels() - 3 ) {
      strip.setPixelColor(strip.numPixels() - 14, strip.Color(0, 0, 0));
    }
    if (j == strip.numPixels() - 4 ) {
      strip.setPixelColor(strip.numPixels() - 13, strip.Color(0, 0, 0));
    }
    if (j == strip.numPixels() - 5 ) {
      strip.setPixelColor(strip.numPixels() - 12, strip.Color(0, 0, 0));
    }
    if (j == strip.numPixels() - 6 ) {
      strip.setPixelColor(strip.numPixels() - 11, strip.Color(0, 0, 0));
    }
    if (j == strip.numPixels() - 7 ) {
      strip.setPixelColor(strip.numPixels() - 10, strip.Color(0, 0, 0));
    }
    if (j == strip.numPixels() - 8 ) {
      strip.setPixelColor(strip.numPixels() - 9, strip.Color(0, 0, 0));
    }

    if (j == strip.numPixels() - 7 ) {
      strip.setPixelColor(strip.numPixels() - 8, strip.Color(0, 0, 0));
    }
    strip.show();
    if (j != 0 ) delay(wait);
  }

}




void setup()
{

#if defined(__AVR_ATtiny85__) && (F_CPU == 16000000)
  clock_prescale_set(clock_div_1);
#endif

  strip.begin();           // INITIALIZE NeoPixel strip object (REQUIRED)
  strip.show();            // Turn OFF all pixels ASAP
  strip.setBrightness(250); // Set BRIGHTNESS to about 1/5 (max = 255)

  btSerial.begin(9600);  // HC-05 default speed in AT command more


}

void loop() // run over and over
{

  while (btSerial.available()) {
    delay(10);

    if ( btSerial.peek() == '!' ) {
      lastMessage = rxMessage;

      rxMessage = btSerial.readStringUntil('\n');
      rxMessage.remove(0, 1);
      rxMessage.remove( rxMessage.indexOf('.'), rxMessage.length()  );
      speedRaito = ((float)rxMessage.toInt());
      speedRaito = 1 / (speedRaito / 10);


      rxMessage = lastMessage;
    }
    else if (btSerial.peek() == '$' ) {
      rxMessage = btSerial.readStringUntil('\n');
      rxMessage.remove(0, 1);
      speedRaito = 1;
   
    }
    else {
      while (btSerial.available() > 50) {
        btSerial.read();
        
      }
      btSerial.read();
    }
  }










  if (rxMessage == "Off") {
    while (!btSerial.available()) {
      strip.clear();
    }
  }
  else if (rxMessage == "Red") {
    while (!btSerial.available()) {
      strip.setBrightness(250);
      stripFill(strip.Color(255, 0,   0));
    }
  }
  else if (rxMessage == "Whi") {
    while (!btSerial.available()) {
      strip.setBrightness(250);
      stripFill(strip.Color(250, 250, 250));
    }
  }
  else if (rxMessage == "Blu") {
    while (!btSerial.available()) {
      strip.setBrightness(250);
      stripFill(strip.Color(0, 0, 255));
    }
  }
  else if (rxMessage == "The") {
    while (!btSerial.available()) {
      strip.setBrightness(250);
      rnd0 = random(100, 255);
      rnd1 = random(100, 255);
      rnd2 = random(100, 255);
      theaterChase(strip.Color(rnd0, rnd1, rnd2), s_chase * speedRaito);
    }
  }
  else if (rxMessage == "Rai") {
    while (!btSerial.available()) {
      rainbow(20 * speedRaito);
    }
  }
  else if (rxMessage == "Dyn") {
    colorWipe(strip.Color(  255, 0,   0), -s_wipe * speedRaito);
    colorWipe(strip.Color(  255 / 3, 255 / 3,  220 / 3), s_wipe * speedRaito);
    colorWipe(strip.Color(  0,   0, 255), -s_wipe * speedRaito);

    while (!btSerial.available()) {
      rnd0 = random(255);
      rnd1 = random(255);
      rnd2 = random(255);
      colorWipe(strip.Color(rnd0, rnd1, rnd2), s_wipe * speedRaito);
      s_wipe = -s_wipe;
    }
  }
  else if (rxMessage == "Fad") {

    while (!btSerial.available()) {
      rnd0 = random(255);
      rnd1 = random(255);
      rnd2 = random(255);
      ledFade(strip.Color(rnd0, rnd1, rnd2), s_fade * speedRaito);
      ledFade(strip.Color(rnd0, rnd1, rnd2), -s_fade * speedRaito);
    }
  }
  else if (rxMessage == "Nig") {

    while (!btSerial.available()) {
      nightRider(120 * speedRaito);
    }
  }
  else if (rxMessage == "Any") {

    rnd0 = random(255);
    rnd1 = random(255);
    rnd2 = random(255);
    while (!btSerial.available()) {
      stripFill(strip.Color(rnd0, rnd1, rnd2));
    }

  }
}
